/*
	slide-2 1.0  jQuery 焦点图控制器2
	Copyright (c) 2011 ayymbirst@gmail.com,qq群:65711267
	Dual licensed under the MIT and GPL licenses
	http://www.cnblogs.com/a_bu/
	Date:2011-3-14
*/
function slide2(option){
	
	var ani = {
		length:null,scrolltimer:null,autotimer:null,scrollcontrol:null,subcontrol:null,autotime:3000,waittime:100,width:null,height:null,mode:null,rv:null,freq:null,isLR:null,auto:true,lock1:false,lock2:false,cls:null,leftbtn:null,rightbtn:null
		////变速器
		,speed:function(option){
			var o = option , abs ,f ,of,v ,r,t,mode;
			if(isNaN(o.offset) || isNaN(o.offset) || !o.callback || o.callback.constructor != Function )
				return;
			o.timer = o.timer||50;
			o.offset = parseInt(o.offset);
			
			f = o.offset > 0 ? 1 : -1;
			
			mode = o.mode || "slow";
			switch(mode){
				case "slow":
					r = o.rv || 1;
					break;
				case "fast":
					r = o.rv || 1;
					break;
				default:
					r = o.rv || 25;
					break;
			}
			var exe = function(){
				if(o.offset === 0){
					clearInterval(t);
					t = null;
					o.over && o.over.constructor === Function && o.over();
					return;
				}
				if(mode === 'slow'){
					of = Math.abs(parseInt(o.offset / 10));
					if(of > r ){
						v = of;
					} else {
						if(Math.abs(o.offset) > r){
							v = r 
						} else {
							v = Math.abs(o.offset);
						}
					}
				}  else  {
					of = Math.abs(o.offset);
					if(r > of){
						v = of;
					} else {
						v = r;
						if(mode === 'fast'){
							r++;
						}
					}
				}

				v *= f;
				o.offset -= v;
				o.callback(v);
			}

			t = setInterval(exe,o.timer);
			return t;
		}
		,event:{start:null,stop:null}
		//获取当前可滚动距离
		,getOffset:function(dir){
			var v1,v2,v3,of
			if(this.isLR){
				v1 = this.scrollcontrol.scrollLeft;
				v2 = this.subcontrol.offsetWidth;
				v3 = this.width;
			} else {
				v1 = this.scrollcontrol.scrollTop;
				v2 = this.subcontrol.offsetHeight;
				v3 = this.height;
			}

			if(dir === "next"){
				of = v2 - v3 - v1;
				if(of > v3)
					of = v3;
			} else {
				if(v1 > v3)
					of = v3;
				else 
					of = v1;

				of *= -1 ;
			}

			return of;
		}
		//滚动命令入口
		,move:function(op,callback,auto){
			var cur = this ,of ,wait ;

			cur.stop();
			of = cur.getOffset(op);

			if(of === 0){
				if( op === "next" && auto)
					callback && typeof callback == "function" && callback(of);
				if(op === "next"){
					if(typeof cur.afterend === "function")
						cur.afterend.call(this,auto);
				} else {
					if(typeof cur.beforefirst === "function")
						cur.beforefirst.call(this,auto);
				}
				return ;
			}
			cur.lock1 = true ;
			cur.scrolltimer = cur.speed({
				offset:of
				,timer:cur.freq
				,mode:cur.mode
				,rv:cur.rv
				,callback:function(v){
					if(cur.isLR){
						cur.scrollcontrol.scrollLeft += v;
					} else {
						cur.scrollcontrol.scrollTop += v;
					}
				}
				,over:function(){
					cur.lock1 = false ;
					if(wait){
						clearTimeout(wait);
						wait = null;
					}
					wait = setTimeout(function(){
						cur.autoScroll();
					},cur.waittime);
				}
			})
			
		}
		//自动滚动控制器
		,autoScroll:function(){
			var cur = this,wait;
			if(cur.autotimer){
				clearInterval(cur.autotimer);
				cur.autotimer = null;
			}
				
			if(cur.auto && !cur.lock1 && !cur.lock2){
				var t,v;
				if(cur.isLR){
					v = cur.scrollcontrol.scrollLeft ;
				} else {
					v = cur.scrollcontrol.scrollTop;
				}

				v *= -1;
				cur.autotimer = setInterval(function(){
					cur.move("next",function(of){
						if(t){
							clearInterval(t);
							t = null;
						}
						cur.lock1 = true;
						t = cur.speed({
							offset:v
							,timer:cur.freq
							,mode:cur.mode
							,rv:cur.rv
							,callback:function(v){
								if(cur.isLR){
									cur.scrollcontrol.scrollLeft += v;
								} else {
									cur.scrollcontrol.scrollTop += v;
								}
							}
							,over:function(){
								cur.lock1 = false ;
								if(wait){
									clearTimeout(wait);
									wait = null;
								}
								wait = setTimeout(function(){
									cur.autoScroll();
								},cur.waittime);
							}
						})
					},true);
				},cur.autotime);
			}
		}
		//停止自动滚动(控制器)
		,stopAutoTimer:function(){
			if(this.autotimer){
				clearInterval(this.autotimer);
				this.autotimer = null;
			}
		}
		//停止滚动
		,stop:function(){
			if(this.scrolltimer){
				clearInterval(this.scrolltimer);
				this.scrolltimer = null;
			}
			this.stopAutoTimer();
		}
		,regEvent:function(obj,name,fun){
			if(obj.addEventListener){
				obj.addEventListener(name,fun,false) ;
			} else if(obj.attachEvent){
				obj.attachEvent("on" + name,fun) ;
			} else {
				obj["on" + name] = fun;
			}
		}
		//初始化
		,ini:function(op){
			this.length = op.length; //张数
			this.scrollcontrol = document.getElementById(op.scrollcontrol); //滚动条容器
			this.subcontrol = document.getElementById(op.subcontrol); //滚动内容部分

			this.width = op.width; //scrollcontrol 宽度
			this.height = op.height; //scrollcontrol 高度
			this.mode = op.mode == "slow"  || op.mode == "fast" ? op.mode : "stand" ; //滚动模式
			this.rv =  op.rv && !isNaN(op.rv) ? op.rv : 25; //滚动模式对应参数
			this.freq = op.freq && !isNaN(op.freq) ? op.freq : 10;  //设置setInterval 第二个参数
			this.isLR = op.isLR === "lr" ? true : false ; //横向or垂直 滚动
			this.auto = typeof op.auto == "undefined" ? this.auto : op.auto ;
			this.autotime = op.autotime && !isNaN(op.autotime) ? op.autotime : this.autotime ;
			this.afterend = op.afterend ;
			this.beforefirst = op.beforefirst;

			var cur = this,wait;
			
			this.regEvent(this.scrollcontrol,"mouseover",function(){
				cur.lock2 = true ;
				cur.stopAutoTimer();
			});
			this.regEvent(this.scrollcontrol,"mouseout",function(){
				cur.lock2 = false ;
				if(wait){
					clearTimeout(wait);
					wait = null;
				}
				wait = setTimeout(function(){cur.autoScroll();},cur.waittime);
			});

			var over = function(e){
				cur.lock2 = true ;
				cur.stopAutoTimer();
			}

			var out = function(e){
				cur.lock2 = false ;
				if(wait){
					clearTimeout(wait);
					wait = null;
				}
				wait = setTimeout(function(){cur.autoScroll();},cur.waittime);
			}

			this.leftbtn = document.getElementById(op.leftbtn);
			this.rightbtn = document.getElementById(op.rightbtn);
			this.regEvent(this.leftbtn,"mouseover",over);
			this.regEvent(this.leftbtn,"click",function(){
				cur.move("prev",false);
			});

			this.regEvent(this.rightbtn,"click",function(){
				cur.move("next",false);
			});

			this.regEvent(this.leftbtn,"mouseout",out);
			this.regEvent(this.rightbtn,"mouseover",over);
			this.regEvent(this.rightbtn,"mouseout",out);
			this.autoScroll();
		}
	}
	ani.ini(option);
	return ani;
}