/*
	slide-1 1.0  jQuery 分页焦点图控制器
	Copyright (c) 2011 ayymbirst@gmail.com,qq群:65711267
	Dual licensed under the MIT and GPL licenses
	http://www.cnblogs.com/a_bu/
	Date:2011-3-14
*/
function slide1(option){
	var ani = {
		length:null,scrolltimer:null,autotimer:null,scrollcontrol:null,autotime:3000,waittime:100,width:null,height:null,mode:null,curindex:-1,lstindex:-1,rv:null,freq:null,isLR:null,auto:true,lock1:false,lock2:false,smallbtn:null,cls:null
		//变速器
		,speed:function(option){
			var o = option , abs ,f ,of,v ,r,t,mode;
			if(isNaN(o.offset) || isNaN(o.offset) || !o.callback || o.callback.constructor != Function )
				return;
			o.timer = o.timer||50;
			o.offset = parseInt(o.offset);
			
			f = o.offset > 0 ? 1 : -1;
			
			mode = o.mode || "slow";
			switch(mode){
				case "slow":
					r = o.rv || 1;
					break;
				case "fast":
					r = o.rv || 1;
					break;
				default:
					r = o.rv || 25;
					break;
			}
			var exe = function(){
				if(o.offset === 0){
					clearInterval(t);
					t = null;
					o.over && o.over.constructor === Function && o.over();
					return;
				}
				if(mode === 'slow'){
					of = Math.abs(parseInt(o.offset / 10));
					if(of > r ){
						v = of;
					} else {
						if(Math.abs(o.offset) > r){
							v = r 
						} else {
							v = Math.abs(o.offset);
						}
					}
				}  else  {
					of = Math.abs(o.offset);
					if(r > of){
						v = of;
					} else {
						v = r;
						if(mode === 'fast'){
							r++;
						}
					}
				}

				v *= f;
				o.offset -= v;
				o.callback(v);
			}

			t = setInterval(exe,o.timer);
			return t;
		}
		,event:{start:null,stop:null}
		//获取当前可滚动距离
		,getOffset:function(){
			if(this.isLR){
				return this.curindex * this.width - this.scrollcontrol.scrollLeft ;
			} else {
				return this.curindex * this.height - this.scrollcontrol.scrollTop;
			}
		}
		//滚动命令入口
		,move:function(op){
			var cur = this ,of ,wait ;
			cur.lock1 = true ;
			cur.stop();
			cur.lstindex = cur.curindex
			if(typeof op === "string"){
				cur.curindex = ++cur.curindex;
			} else {
				cur.curindex = op;
			}
			cur.curindex = cur.curindex % cur.length;

			of = cur.getOffset();
			if(cur.event.start){
				cur.event.start.call(this,cur.lstindex,cur.curindex);
			}

			if(cur.cls){
				if(typeof cur.cls === "string"){
					if(cur.lstindex != -1){
						cur.smallbtn[cur.lstindex].className = cur.smallbtn[cur.lstindex].className.replace(cur.cls,"");
					}

					cur.smallbtn[cur.curindex].className += " " +cur.cls;

				} else if(typeof cur.cls === "function"){
					//自定义
					cur.cls.call(this,cur.smallbtn,cur.lstindex,cur.curindex);
				}
			}
			cur.scrolltimer = cur.speed({
				offset:of
				,timer:cur.freq
				,mode:cur.mode
				,rv:cur.rv
				,callback:function(v){
					if(cur.isLR){
						cur.scrollcontrol.scrollLeft += v;
					} else {
						cur.scrollcontrol.scrollTop += v;
					}
				}
				,over:function(){
					cur.lock1 = false ;
					if(wait){
						clearTimeout(wait);
						wait = null;
					}
					wait = setTimeout(function(){
						cur.autoScroll();
					},cur.waittime);
					if(cur.event.stop){
						cur.event.stop.call(this,cur.lstindex,cur.curindex);
					}
				}
			})
			
		}
		//自动滚动控制器
		,autoScroll:function(){
			var cur = this;
			if(cur.autotimer){
				clearInterval(cur.autotimer);
				cur.autotimer = null;
			}
				
			if(cur.auto && !cur.lock1 && !cur.lock2){
				cur.autotimer = setInterval(function(){
					cur.move("next");
				},cur.autotime);
			}
		}
		//停止自动滚动(控制器)
		,stopAutoTimer:function(){
			if(this.autotimer){
				clearInterval(this.autotimer);
				this.autotimer = null;
			}
		}
		//停止滚动
		,stop:function(){
			if(this.scrolltimer){
				clearInterval(this.scrolltimer);
				this.scrolltimer = null;
			}
			this.stopAutoTimer();
		}
		,regEvent:function(obj,name,fun){
			if(obj.addEventListener){
				obj.addEventListener(name,fun,false) ;
			} else if(obj.attachEvent){
				obj.attachEvent("on" + name,fun) ;
			} else {
				obj["on" + name] = fun;
			}
		}
		//初始化
		,ini:function(op){
			this.length = op.length; //张数
			this.scrollcontrol = document.getElementById(op.scrollcontrol); //滚动条容器
			this.width = op.width; //scrollcontrol 宽度
			this.height = op.height; //scrollcontrol 高度

			this.mode = op.mode == "slow"  || op.mode == "fast" ? op.mode : "stand" ; //滚动模式
			this.rv =  op.rv && !isNaN(op.rv) ? op.rv : 25; //滚动模式对应参数
			this.freq = op.freq && !isNaN(op.freq) ? op.freq : 10;  //设置setInterval 第二个参数
			this.isLR = op.isLR === "lr" ? true : false ; //横向or垂直 滚动
			op.defindex = op.defindex || 0;
			this.event.start = op.start;
			this.event.stop = op.stop;
			this.auto = typeof op.auto == "undefined" ? this.auto : op.auto  ;
			
			this.smallbtn = op.smallbtn;
			this.cls = op.cls;
			this.autotime = op.autotime && !isNaN(op.autotime) ? op.autotime : this.autotime ;
			var cur = this,wait;
			var over = function(e){
				var e = e || window.event;
				var obj = e.target || e.srcElement;
				cur.lock2 = true ;
				cur.move(obj.index);
			}

			var out = function(e){
				cur.lock2 = false ;
				if(wait){
					clearTimeout(wait);
					wait = null;
				}
				wait = setTimeout(function(){cur.autoScroll();},cur.waittime);
			}
			for(var i = 0 ; i < op.smallbtn.length ; i++){
				this.regEvent(op.smallbtn[i],"mouseover",over);
				this.regEvent(op.smallbtn[i],"mouseout",out);
				op.smallbtn[i].index = i ;
			}

			this.regEvent(this.scrollcontrol,"mouseover",function(){
				cur.lock2 = true ;
				cur.stopAutoTimer();
			});
			this.regEvent(this.scrollcontrol,"mouseout",function(){
				cur.lock2 = false ;
				if(wait){
					clearTimeout(wait);
					wait = null;
				}
				wait = setTimeout(function(){cur.autoScroll();},cur.waittime);
			})


			this.move(op.defindex);
		}
	}
	ani.ini(option);
	return ani;
}